<template>
  <div class="flex flex-col w-full" id="others-module">
    <div v-if="isHidden" class="flex justify-between items-center mb-4">
      <span class="text-2xl font-bold --text2 leading-7">{{ displayName }}</span>
    </div>
    <div class="grid w-full grid-cols-3">
      <div
        v-for="(item, index) in childProperties"
        :key="index"
        :class="['col-span-1', { 'ml-2.5': index !== 0 }]"
        :id="item.HyperLink.replace('/', '')"
      >
        <div class="relative rounded-lg h-52 bg-background1">
          <nuxt-link :to="item.HyperLink">
            <div
              class="img-module-container relative aspect-[181/93] w-full h-full group rounded-[8px] overflow-hidden"
            >
              <div
                class="absolute top-0 left-0 flex w-full h-full pointer-events-none"
              >
                <div
                  class="relative flex items-center justify-center w-full h-full"
                >
                  <img
                    v-if="item.ImagePath && item.ImagePath.length > 0"
                    :src="item.ImagePath"
                    loading="lazy"
                    class="object-contain w-full img-scale"
                    @error="
                      (e) =>
                        isHandleDefaultImageRender(item.ImagePath)
                          ? onErrorDefaultImage(e, item.ImagePath)
                          : e.target.remove()
                    "
                  />
                </div>
              </div>
            </div>
          </nuxt-link>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { computed, defineProps } from "vue";
import { ThemePropertiesFromApiDto } from "~~/models/companyThemePropertiesRespone";
import useOthersModule from "~~/composables/lobby/useOthersModule";
import commonHelper from "@/utils/commonHelper";

const props = defineProps<{
  data: ThemePropertiesFromApiDto;
}>();

const { property, initSubProperties, childProperties } = useOthersModule(props);
const { onErrorDefaultImage, isHandleDefaultImageRender } = commonHelper;

onMounted(() => {
  initSubProperties();
});

const displayName = computed(() => property.value.Text?.Title);
const isHidden = computed(() => property.value.Text?.IsHidden);
</script>
<style lang="scss">
.img-scale {
  scale: 1.01;
  transition: scale 0.5s ease-in-out;
}
.img-module-container:hover {
  .img-scale {
    scale: 1.1;
  }
}
</style>
